/**********************************************************************/
/*   This program is developed by Borland C++ 3.1                      */
/*   For  PCI-1602L                                                    */
/***********************************************************************/
/*  Demo 30: One P1602 Card P1602_AdsPacer Function demo.              */
/*  First Card:  To acquire A/D CH:2, CH:3, CH:4 250 times.            */
/*  The sampling rate is 8M/wFreqDiv                                   */
/***********************************************************************/
#define  MYLIB
#include "P1602.H"

#define  DATACOUNT  250

WORD   wDaNum=180,wAdClk=80;
float  fV2[DATACOUNT];  /* AD ch:2 buffer */
float  fV3[DATACOUNT];  /* AD ch:3 buffer */
float  fV4[DATACOUNT];  /* AD ch:4 buffer */

WORD   wPlot2[500];  /* transformed into wave form */
WORD   wPlot3[500];  /* transformed into wave form */
WORD   wPlot4[500];  /* transformed into wave form */
WORD   old_wPlot2[500];  /* transformed into wave form */
WORD   old_wPlot3[500];  /* transformed into wave form */
WORD   old_wPlot4[500];  /* transformed into wave form */
int main()
{
   WORD    i,j;
   WORD    wBoards,wRetVal,wFreqDiv,wConfig;
   WORD    wDIOdata;
   float   fVal;
   char    ch,cShow[80];
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   clrscr();

   /* initiaing P1602 card and detect how many P1602 card in PC */
   wRetVal=P1602_DriverInit(&wBoards);
   printf("Threr are %d P1602 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1602 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1602 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1602_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
				     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   printf("--- Enter the Config Code  --------------------------\n");
   printf(" For Example: PCI-1602(Low Gain) -->  Config:0-3(hex)\n");
   printf("Enter Config(hex):");   scanf("%x",&wConfig);
   printf("\nPlease Enter the Freq Divisior(8000): ");
   scanf("%d",&wFreqDiv);

   /* The P1602_ActiveBoard() function must be used to active a board, */
   /* then all operation will take effect to the actived board.        */
   printf("Now Active First P1602 Card...\n");
   P1602_ActiveBoard( 0 );

   graphic_init();
   cleardevice();

   sprintf(cShow,"Pacer Trigger Sampling Rate:%.2f KHz", 8000.0/wFreqDiv);
   setcolor(RED);
   outtextxy(120,10,cShow);

   for (i=0; i<DATACOUNT; i++)
   {
       fV2[i]=fV3[i]=fV4[i]=0;
       old_wPlot2[i]=old_wPlot3[i]=old_wPlot4[i]=0;
       wPlot2[i]=wPlot3[i]=wPlot4[i]=0;
   }

   for(  ;   ; )
   {
      /*** Channel 2 ***/
      wRetVal=P1602_SetChannelConfig(2,wConfig);
      wRetVal+=P1602_DelayUs(3);      /* 3 us settling */
      wRetVal=P1602_AdsPacer(fV2,DATACOUNT,wFreqDiv);
      if( wRetVal )
      {
	 putch(0x07);  putch(0x07);  putch(0x07);
	 printf("Error in seting channel 2\n");
	 goto ret_label;
      }

      /*** Channel 3 ***/
      wRetVal=P1602_SetChannelConfig(3,wConfig);
      wRetVal+=P1602_DelayUs(3);      /* 3 us settling */
      wRetVal=P1602_AdsPacer(fV3,DATACOUNT,wFreqDiv);
      if( wRetVal )
      {
	 putch(0x07);  putch(0x07);  putch(0x07);
	 printf("Error in seting channel 3\n");
	 goto ret_label;
      }

      /*** Channel 4 ***/
      wRetVal=P1602_SetChannelConfig(4,wConfig);
      wRetVal+=P1602_DelayUs(3);     /* 3 us settling */
      wRetVal=P1602_AdsPacer(fV4,DATACOUNT,wFreqDiv);
      if( wRetVal )
      {
         putch(0x07);  putch(0x07);  putch(0x07);
         printf("Error in seting channel 4\n");
         goto ret_label;
		}

		setcolor(WHITE);
		for(i=0; i<DATACOUNT-1; i++)  /*** erase the wave form ***/
		{
	 line(10+i,old_wPlot2[i],10+i+1,old_wPlot2[i+1]);
	 line(10+i,old_wPlot3[i],10+i+1,old_wPlot3[i+1]);
	 line(10+i,old_wPlot4[i],10+i+1,old_wPlot4[i+1]);
		}


		setcolor(RED);
		sprintf(cShow,"Channel 2's wave form:");
		outtextxy(10,30,cShow);
		for(i=0; i<DATACOUNT; i++)  /* channel 2's data and its wave form */
	 wPlot2[i]=30-(fV2[i]+5.0)*11.0;
		for(i=0; i<DATACOUNT-1; i++)  /* plot channel 2's wave form       */
	 line(10+i,wPlot2[i],10+i+1,wPlot2[i+1]);

		sprintf(cShow,"Channel 3's wave form:");
		outtextxy(10,150,cShow);
		for(i=0; i<DATACOUNT; i++)  /* channel 3's data and its wave form */
	 wPlot3[i]=140-(fV3[i]+5.0)*11.0;
		for(i=0; i<DATACOUNT-1; i++)  /* plot channel 3's wave form */
	 line(10+i,wPlot3[i],10+i+1,wPlot3[i+1]);

		sprintf(cShow,"Channel 4's wave form:");
		outtextxy(10,240,cShow);
		for(i=0; i<DATACOUNT; i++)  /* channel 4's data and its wave form */
	 wPlot4[i]=240-(fV4[i]+5.0)*11.0;
		for(i=0; i<DATACOUNT-1; i++)  /* plot channel 4's wave form */
	 line(10+i,wPlot4[i],10+i+1,wPlot4[i+1]);

		/***** Restore the wave form *****/
		for(i=0; i<DATACOUNT; i++)
		{
			old_wPlot2[i]=wPlot2[i];
			old_wPlot3[i]=wPlot3[i];
			old_wPlot4[i]=wPlot4[i];
		}

		if( kbhit() )
		{
			ch=getch(); /*** ESC press ***/
			if( ch==27 )
				break;
		}
	}

 ret_label:
	cleardevice();
	closegraph();

	P1602_DriverClose();
	return 0;
}

graphic_init()
{
	int driver,mode,char_size;

	driver=EGA;
	mode=EGAHI;
	initgraph(&driver,&mode,"");
	setactivepage(0);
	setvisualpage(0);
	setcolor(0);
	setbkcolor(WHITE);
	settextstyle(SMALL_FONT,HORIZ_DIR,6);
	return 0;
}

