/*****************************************************************************/
/*   This program is developed by MicroSoft C 5.1                             */
/******************************************************************************/
/*  Demo 15: One P1602 Card demo.                                             */
/*  For identify Card Number easily, Using the digital output and digital     */
/*     input function.                                                        */
/******************************************************************************/
#define  MYLIB
#include "P1602.H"

int main()
{
   int     i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata,wOutput;
   DWORD   dwCount=0;
   float   fVal;
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

  _clearscreen(0);
   gotoxy(1,1);

   // initiaing P1602 card and detect how many P1602 card in PC
   wRetVal=P1602_DriverInit(&wBoards);
   printf("Threr are %d P1602 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1602 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1602 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1602_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
                                     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   // The P1602_ActiveBoard() function must be used to active a board,
   // then all operation will take effect to the actived board.

   wOutput=0x5555;
   for( ; ; )
   {
      gotoxy(1,8);
      printf("Counter=%ld...\n",dwCount);
      for(i=0; i<wBoards; i++)
      {
         P1602_ActiveBoard( i );
         P1602_Do(wOutput);     // Digital output
         P1602_Di(&wDIOdata);   // Digital input
         gotoxy(1,9+i);
         if( wOutput==wDIOdata )
         {
            printf("OK, %dth Card: Digital Output -> %04xH  |  Digital Input -> %04xH\n",
                                                            i,wOutput,wDIOdata);
         }
         else
            printf("    %dth Card: Digital Output -> %04xH  |  Digital Input -> %04xH\n",
                                                            i,wOutput,wDIOdata);
      }
      dwCount++;
      if( wOutput==0x5555 )
         wOutput=0xaaaa;
      else
         wOutput=0x5555;
      for(j=0; j<1000; j++)
         P1602_DelayUs(1000);  // delay 300 ms just for display purpose

      if( kbhit() )
         break;
   }
   return 0;
}

