/**********************************************************************/
/*   This program is developed by Microsoft C 5.1                      */
/***********************************************************************/
/*  Demo 17: One P1602 Card MagicScan Function demo.                   */
/*    To acquire all A/D channels, then display the CH:0, CH:1, CH:15, */
/*    CH:16 and CH:17's data for those channels.                       */
/***********************************************************************/
#define  MYLIB
#include "P1602.H"

#define  DATACOUNT  100  // how many data is scan for a A/D channel

WORD   wDaNum=90,wAdClk=24;

WORD   wV[32][DATACOUNT];  // AD CH:0-31 Buffer

WORD   wPlot0[500]; //  transformed into wave form
int main()
{
   WORD    i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   float   fVal;
   char    cShow[80];
   WORD    wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   _clearscreen(0);
   gotoxy(1,1);

   // initiaing P1602 card and detect how many P1602 card in PC
   wRetVal=P1602_DriverInit(&wBoards);
   printf("Threr are %d P1602 Cards in this PC\n",wBoards);

   if( wBoards==0 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("There are no P1602 card in this PC !!!\n");
      exit(0);
   }

   /* dump every P1602 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1602_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
                                     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }

   // The P1602_ActiveBoard() function must be used to active a board,
   // then all operation will take effect to the actived board.

   printf("--------------------------------------------------\n");
   printf("Now Active First P1602 Card...\n");
   P1602_ActiveBoard( 0 );

   P1602_Do(0x1234);     // Digital output
   P1602_Di(&wDIOdata);  // Digital input
   printf("Digital Output -> 1234H  |  Digital Input -> %04xH\n",wDIOdata);
   printf("\nHit any key to show data.\n");
   getch();

   for(i=0; i<32; i++)
      for (j=0; j<DATACOUNT; j++)
         wV[i][j]=0;

   wRetVal=P1602_ClearScan();
   wRetVal += P1602_AddToScan(0,0,1,0,0,0);  // CH:0
   wRetVal += P1602_SaveScan(0,wV[0]);

   wRetVal += P1602_AddToScan(1,0,1,0,0,0);  // CH:1
   wRetVal += P1602_SaveScan(1,wV[1]);

   wRetVal += P1602_AddToScan(2,0,1,0,0,0);  // CH:2
   wRetVal += P1602_SaveScan(2,wV[2]);

   wRetVal += P1602_AddToScan(3,0,1,0,0,0); // CH:3
   wRetVal += P1602_SaveScan(3,wV[3]);

   wRetVal += P1602_AddToScan(4,0,1,0,0,0); // CH:4
   wRetVal += P1602_SaveScan(4,wV[4]);

   wRetVal += P1602_AddToScan(5,0,1,0,0,0); // CH:5
   wRetVal += P1602_SaveScan(5,wV[5]);

   wRetVal += P1602_AddToScan(6,0,1,0,0,0); // CH:6
   wRetVal += P1602_SaveScan(6,wV[6]);

   wRetVal += P1602_AddToScan(7,0,1,0,0,0); // CH:7
   wRetVal += P1602_SaveScan(7,wV[7]);

   wRetVal += P1602_AddToScan(8,0,1,0,0,0); // CH:8
   wRetVal += P1602_SaveScan(8,wV[8]);

   wRetVal += P1602_AddToScan(9,0,1,0,0,0); // CH:9
   wRetVal += P1602_SaveScan(9,wV[9]);

   wRetVal += P1602_AddToScan(10,0,1,0,0,0); // CH:10
   wRetVal += P1602_SaveScan(10,wV[10]);

   wRetVal += P1602_AddToScan(11,0,1,0,0,0); // CH:11
   wRetVal += P1602_SaveScan(11,wV[11]);

   wRetVal += P1602_AddToScan(12,0,1,0,0,0); // CH:12
   wRetVal += P1602_SaveScan(12,wV[12]);

   wRetVal += P1602_AddToScan(13,0,1,0,0,0); // CH:13
   wRetVal += P1602_SaveScan(13,wV[13]);

   wRetVal += P1602_AddToScan(14,0,1,0,0,0); // CH:14
   wRetVal += P1602_SaveScan(14,wV[14]);

   wRetVal += P1602_AddToScan(15,0,1,0,0,0); // CH:15
   wRetVal += P1602_SaveScan(15,wV[15]);

   wRetVal += P1602_AddToScan(16,0,1,0,0,0); // CH:16
   wRetVal += P1602_SaveScan(16,wV[16]);

   wRetVal += P1602_AddToScan(17,0,1,0,0,0); // CH:17
   wRetVal += P1602_SaveScan(17,wV[17]);

   wRetVal += P1602_AddToScan(18,0,1,0,0,0); // CH:18
   wRetVal += P1602_SaveScan(18,wV[18]);

   wRetVal += P1602_AddToScan(19,0,1,0,0,0); // CH:19
   wRetVal += P1602_SaveScan(19,wV[19]);

   wRetVal += P1602_AddToScan(20,0,1,0,0,0); // CH:20
   wRetVal += P1602_SaveScan(20,wV[20]);

   wRetVal += P1602_AddToScan(21,0,1,0,0,0); // CH:21
   wRetVal += P1602_SaveScan(21,wV[21]);

   wRetVal += P1602_AddToScan(22,0,1,0,0,0); // CH:22
   wRetVal += P1602_SaveScan(22,wV[22]);

   wRetVal += P1602_AddToScan(23,0,1,0,0,0); // CH:23
   wRetVal += P1602_SaveScan(23,wV[23]);

   wRetVal += P1602_AddToScan(24,0,1,0,0,0); // CH:24
   wRetVal += P1602_SaveScan(24,wV[24]);

   wRetVal += P1602_AddToScan(25,0,1,0,0,0); // CH:25
   wRetVal += P1602_SaveScan(25,wV[25]);

   wRetVal += P1602_AddToScan(26,0,1,0,0,0); // CH:26
   wRetVal += P1602_SaveScan(26,wV[26]);

   wRetVal += P1602_AddToScan(27,0,1,0,0,0); // CH:27
   wRetVal += P1602_SaveScan(27,wV[27]);

   wRetVal += P1602_AddToScan(28,0,1,0,0,0); // CH:28
   wRetVal += P1602_SaveScan(28,wV[28]);

   wRetVal += P1602_AddToScan(29,0,1,0,0,0); // CH:29
   wRetVal += P1602_SaveScan(29,wV[29]);

   wRetVal += P1602_AddToScan(30,0,1,0,0,0); // CH:30
   wRetVal += P1602_SaveScan(30,wV[30]);

   wRetVal += P1602_AddToScan(31,0,1,0,0,0); // CH:31
   wRetVal += P1602_SaveScan(31,wV[31]);

   wRetVal=P1602_StartScan(80,DATACOUNT);
   if(wRetVal==0)
   {
      printf("1st Card: P1602_StartScan OK.");
   }
   else
   {
      putch(0x07);
      printf("1st Card: P1602_StartScan Error !!!, return=%x\n\n",wRetVal);
      exit(0);
   }

   printf("Channel 0's first 12 data:\n");
   for(i=0; i<12; i++)
   {
      printf("[%02d]=%04xH  ",i,wV[0][i]);
      if( i%4==3 )  printf("\n");
   }

   printf("Channel 1's first 12 data:\n");
   for(i=0; i<12; i++)
   {
      printf("[%02d]=%04xH  ",i,wV[1][i]);
      if( i%4==3 )  printf("\n");
   }

   printf("Channel 15's first 12 data:\n");
   for(i=0; i<12; i++)
   {
      printf("[%02d]=%04xH  ",i,wV[15][i]);
      if( i%4==3 )  printf("\n");
   }

   printf("Channel 16's first 12 data:\n");
   for(i=0; i<12; i++)
   {
      printf("[%02d]=%04xH  ",i,wV[16][i]);
      if( i%4==3 )  printf("\n");
   }

   printf("Channel 17's first 12 data:\n");
   for(i=0; i<12; i++)
   {
      printf("[%02d]=%04xH  ",i,wV[17][i]);
      if( i%4==3 )  printf("\n");
   }

   P1602_DriverClose();
   return 0;
}
