/**********************************************************************/
/*   This program is developed by Microsoft 5.1                        */
/***********************************************************************/
/*  Demo 2: Two P1602 Cards Demos.                                     */
/*    Basic operation onto P1602 card.                                 */
/*    => P1602_Init(), P1602_ActiveBoard(), P1602_Di(), P1602_Do()     */
/***********************************************************************/
#define  MYLIB
#include "P1602.H"

int main()
{
   int     i,j;
   WORD    wBoards,wRetVal;
   WORD    wDIOdata;
   float   fVal,fAdVals[5];
   WORD   wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda;

   _clearscreen(0);
   gotoxy(1,1);

   /* initiaing P1602 card and detect how many P1602 card in PC */
   wRetVal=P1602_DriverInit(&wBoards);
   printf("Threr are %d P1602 Cards in this PC\n",wBoards);

   if( wBoards<=1 )
   {
      putch(0x07);  putch(0x07);  putch(0x07);
      printf("Please install two P1602 cards in this PC !!!\n");
      exit(0);
   }

   /* dump every P1602 card's configuration address space */
   printf("The Configuration Space ->   Timer   Control   DIO    AD/DA\n");
   for(i=0; i<wBoards; i++)
   {
      P1602_GetConfigAddressSpace(i,&wAddrTimer,&wAddrCtrl,&wAddrDio,&wAddrAdda);
      printf("Card %02d:  Timer:%04xH  Ctrl:%04xH  Dio:%04xH  Adda:%04xH\n",
                                     i,wAddrTimer,wAddrCtrl,wAddrDio,wAddrAdda);
   }


   /* The P1602_ActiveBoard() function must be used to active a board, */
   /* then all operation will take effect to the actived board.        */

   /***********************************************************/
   /*               Now Active First P1602 Card.              */
   /***********************************************************/
   printf("--------------------------------------------------\n");
   printf("Now Active First P1602 Card...\n");
   P1602_ActiveBoard( 0 );

   P1602_Do(0x55aa);     /* Digital output */
   P1602_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> 55aaH  |  Digital Input -> %04xH\n",wDIOdata);

   wRetVal=P1602_Da(0,0xFFF);   /* DA CH:0 output 0xFFF */
   if(wRetVal==0)
      printf("DA CH:0 output 0xFFF.\n");
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("DA CH:0 Error !!!\n");
      exit(0);
   }

   wRetVal=P1602_Da(1,0xA00);  /* DA CH:1 output 0xA00 */
   if(wRetVal==0)
      printf("DA CH:1 output 0xA00.\n");
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("DA CH:1 Error !!!\n");
      exit(0);
   }

   wRetVal=P1602_SetChannelConfig(0,1); // +/- 5V range for PCI-1602
   wRetVal+=P1602_DelayUs(3);  //  3 us settling time for PCI-1602

   wRetVal+=P1602_AdPolling(&fVal);
   if (wRetVal==0)
      printf("(5.0V Range) AdPolling CH:0 -> %5.4f\n",fVal);
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("(5.0V Range) AdPolling CH:0 Error !!!\n");
      exit(0);
   }

   /*---------------- CH:1---------------------------*/
   wRetVal=P1602_SetChannelConfig(1,1); // +/- 5V range for PCI-1602
   wRetVal+=P1602_DelayUs(3);  //  3 us settling time for PCI-1602

   wRetVal+=P1602_AdPolling(&fVal);
   if (wRetVal==0)
      printf("(5.0V Range) AdPolling CH:1 -> %5.4f\n",fVal);
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("(5.0V Range) AdPolling CH:1 Error !!!\n");
      exit(0);
   }

   /***********************************************************/
   /*             Now Active Second P1602 Card.              */
   /***********************************************************/
   printf("--------------------------------------------------\n");
   printf("Now Active Second P1602 Card...\n");
   P1602_ActiveBoard( 1 );

   P1602_Do(0xaa55);     /* Digital output */
   P1602_Di(&wDIOdata);  /* Digital input  */
   printf("Digital Output -> aa55H  |  Digital Input -> %04xH\n",wDIOdata);

   wRetVal=P1602_Da(0,0xFFF);   /* DA CH:0 output 0x900 */
   if(wRetVal==0)
      printf("DA CH:0 output 0xFFF.\n");
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("DA CH:0 Error !!!\n");
      exit(0);
   }

   wRetVal=P1602_Da(1,0xA00);  /* DA CH:1 output 0xA00 */
   if(wRetVal==0)
      printf("DA CH:1 output 0xA00.\n");
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("DA CH:1 Error !!!\n");
      exit(0);
   }

   wRetVal=P1602_SetChannelConfig(0,0); // +/- 5V range for PCI-1602
   wRetVal+=P1602_DelayUs(3);  //  3 us settling time for PCI-1602

   wRetVal+=P1602_AdPolling(&fVal);
   if (wRetVal==0)
      printf("(5.0V Range) AdPolling CH:0 -> %5.4f\n",fVal);
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("(5.0V Range) AdPolling CH:0 Error !!!\n");
      exit(0);
   }

   /*---------------- CH:1---------------------------*/
   wRetVal=P1602_SetChannelConfig(1,1); // +/- 5V range for PCI-1602
   wRetVal+=P1602_DelayUs(23); // 3 us settling time for PCI-1602
   wRetVal+=P1602_AdPolling(&fVal);
   if (wRetVal==0)
      printf("(5.0V Range) AdPolling CH:1 -> %5.4f\n",fVal);
   else
   {
      putch(0x07); putch(0x07); putch(0x07);
      printf("(5.0V Range) AdPolling CH:1 Error !!!\n");
      exit(0);
   }

   P1602_DriverClose();
   return 0;
}

